// 2000/10/22 Ogasawara Hiroyuki


#include	"linux/net.h"

extern int	_zx_socketcall( int call, unsigned long *args );

#define		socklen_t	int

int
_zx_socket( int domain, int type, int protocol )
{
	unsigned long	_arg[3];
	_arg[0]= (unsigned long)domain;
	_arg[1]= (unsigned long)type;
	_arg[2]= (unsigned long)protocol;
	return	_zx_socketcall( SYS_SOCKET, _arg );
}

int
_zx_bind( int sockfd, struct sockaddr *myaddr, socklen_t addrlen )
{
	unsigned long	_arg[3];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)myaddr;
	_arg[2]= (unsigned long)addrlen;
	return	_zx_socketcall( SYS_BIND, _arg );
}


int
_zx_connect( int sockfd, struct sockaddr *servaddr, socklen_t addrlen )
{
	unsigned long	_arg[3];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)servaddr;
	_arg[2]= (unsigned long)addrlen;
	return	_zx_socketcall( SYS_CONNECT, _arg );
}

int
_zx_listen( int sockfd, int backlog )
{
	unsigned long	_arg[2];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)backlog;
	return	_zx_socketcall( SYS_LISTEN, _arg );
}


int
_zx_accept( int sockfd, struct sockaddr *addr, socklen_t *addr_len )
{
	unsigned long	_arg[3];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)addr;
	_arg[2]= (unsigned long)addr_len;
	return	_zx_socketcall( SYS_ACCEPT, _arg );
}


int
_zx_getsockname( int sockfd, struct sockaddr *name, socklen_t *namelen )
{
	unsigned long	_arg[3];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)name;
	_arg[2]= (unsigned long)namelen;
	return	_zx_socketcall( SYS_GETSOCKNAME, _arg );
}

int
_zx_getpeername( int sockfd, struct sockaddr *name, socklen_t *namelen )
{
	unsigned long	_arg[3];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)name;
	_arg[2]= (unsigned long)namelen;
	return	_zx_socketcall( SYS_GETPEERNAME, _arg );
}

int
_zx_socketpair( int sockfd, int type, int protocol, int sv[2] )
{
	unsigned long	_arg[4];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)type;
	_arg[2]= (unsigned long)protocol;
	_arg[3]= (unsigned long)sv;
	return	_zx_socketcall( SYS_SOCKETPAIR, _arg );
}


int
_zx_send( int sockfd, const void *msg, size_t len, int flags )
{
	unsigned long	_arg[4];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)msg;
	_arg[2]= (unsigned long)len;
	_arg[3]= (unsigned long)flags;
	return	_zx_socketcall( SYS_SEND, _arg );
}

int
_zx_sendto( int sockfd, const void *msg, size_t len, int flags,
		const struct sockaddr *to, socklen_t tolen )
{
	unsigned long	_arg[6];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)msg;
	_arg[2]= (unsigned long)len;
	_arg[3]= (unsigned long)flags;
	_arg[4]= (unsigned long)to;
	_arg[5]= (unsigned long)tolen;
	return	_zx_socketcall( SYS_SENDTO, _arg );
}


int
_zx_recv( int sockfd, void *buf, size_t len, int flags )
{
	unsigned long	_arg[4];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)buf;
	_arg[2]= (unsigned long)len;
	_arg[3]= (unsigned long)flags;
	return	_zx_socketcall( SYS_RECV, _arg );
}

int
_zx_recvfrom( int sockfd, void *buf, size_t len, int flags,
		struct sockaddr *from, socklen_t fromlen )
{
	unsigned long	_arg[6];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)buf;
	_arg[2]= (unsigned long)len;
	_arg[3]= (unsigned long)flags;
	_arg[4]= (unsigned long)from;
	_arg[5]= (unsigned long)fromlen;
	return	_zx_socketcall( SYS_RECVFROM, _arg );
}

int
_zx_shutdown( int sockfd, int how )
{
	unsigned long	_arg[2];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)how;
	return	_zx_socketcall( SYS_SHUTDOWN, _arg );
}

int
_zx_setsockopts( int sockfd, int level, int optname,
				const void *optval, socklen_t optlen )
{
	unsigned long	_arg[5];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)level;
	_arg[2]= (unsigned long)optname;
	_arg[3]= (unsigned long)optval;
	_arg[4]= (unsigned long)optlen;
	return	_zx_socketcall( SYS_SETSOCKOPT, _arg );
}

int
_zx_getsockopts( int sockfd, int level, int optname,
				void *optval, socklen_t *optlen )
{
	unsigned long	_arg[5];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)level;
	_arg[2]= (unsigned long)optname;
	_arg[3]= (unsigned long)optval;
	_arg[4]= (unsigned long)optlen;
	return	_zx_socketcall( SYS_GETSOCKOPT, _arg );
}

int
_zx_sendmsg( int sockfd, const struct msghdr *msg, int flags )
{
	unsigned long	_arg[3];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)msg;
	_arg[2]= (unsigned long)flags;
	return	_zx_socketcall( SYS_SENDMSG, _arg );
}

int
_zx_recvmsg( int sockfd, struct msghdr *msg, int flags )
{
	unsigned long	_arg[3];
	_arg[0]= (unsigned long)sockfd;
	_arg[1]= (unsigned long)msg;
	_arg[2]= (unsigned long)flags;
	return	_zx_socketcall( SYS_RECVMSG, _arg );
}






