//--------------------------------------------------------------------------

#include	"crystal.h"

#define		OBJECT_NAME	unsigned long

#include	<asm/unistd.h>		/* include/asm-sh/unsitd.h */

#include	<linux/types.h>
#include	<linux/utime.h>
#include	<linux/time.h>
#include	<linux/times.h>
#include	<linux/signal.h>
#include	<linux/resource.h>
#include	<linux/dirent.h>
#include	<asm/statfs.h>
#include	<asm/stat.h>
#include	<linux/kernel.h>
#include	<linux/utsname.h>
#include	<linux/timex.h>
#include	<linux/uio.h>
#include	<asm/poll.h>
#include	<linux/nfsd/syscall.h>

unsigned long	dbg_regs[16];

struct zx_syscall {
	int sys_no;
	int a1;
	int a2;
	int a3;
	int a4;
	int a5;
};

struct zx_sysret {
	int status;
	int retval;
};

#define	ZX_SYSCALL_STAT_INVAL	(-1)
#define ZX_SYSCALL_STAT_NORMAL	(0)
#define ZX_SYSCALL_STAT_SIGNAL	1

static char	__dummy;

#define ZX_TOUCH(x)	(__dummy= *(char*)(x))

#define ZX_ZS_TOUCH(x)	\
	do { \
		if(x != 0){ \
			ZX_TOUCH(x); \
			if (sizeof(*(x)) > 0) \
			    ZX_TOUCH((char *)(x) + sizeof(*(x)) -1); \
		} \
	} while (0)

#define ZX_S_TOUCH(x)	\
	do { \
		ZX_TOUCH(x); \
		if (sizeof(*(x)) > 0) \
		    ZX_TOUCH((char *)(x) + sizeof(*(x)) -1); \
	} while (0)



#define ZX_PAGE_SIZE	0x0400	/* ? */

int errno;
extern int errno;

#if 0 
#define SYSCALL_PRELUDE(no) \
	OBJECT_NAME callq, retq, name; \
	QUEUE_PBOX cbox, rbox; \
	struct zx_syscall callpack; \
	struct zx_sysret retpack; \
	int v; \
	callq = 0x4c430001; \
	retq = 0x4c520001; \
	callpack.sys_no = no;
#else
#define SYSCALL_PRELUDE(no) \
	OBJECT_NAME callq, retq, name; \
	QUEUE_PBOX cbox, rbox; \
	struct zx_syscall callpack; \
	struct zx_sysret retpack; \
	int v; \
retry_write: \
	callq = ((name = self_getname()) & 0xffff) | 0x4c430000; \
	retq = (name & 0xffff) | 0x4c520000; \
	callpack.sys_no = no;
#endif

#define SYSCALL_ARGSET(argname)	callpack.argname = argname;

#define SYSCALL_POSTLUDE \
	cbox.data = (char *)&callpack; \
	cbox.size = sizeof(callpack); \
	cbox.timeout = -1; \
	queue_write(callq, &cbox); \
retry_read: \
	retq = ((name = self_getname()) & 0xffff) | 0x4c520000; \
	retpack.retval = 0; \
	rbox.data = (char *)&retpack; \
	retpack.status = ZX_SYSCALL_STAT_INVAL; \
	rbox.size = sizeof(retpack); \
	rbox.timeout = -1; \
	queue_read(retq, &rbox); \
	switch (retpack.status){ \
	case ZX_SYSCALL_STAT_INVAL: \
		goto retry_read; \
	case ZX_SYSCALL_STAT_SIGNAL: \
		goto retry_write;  \
	default: ;\
	} \
     	v = retpack.retval; \
	if (v < 0) { \
		errno = -v; \
		v = -1; \
	} \
	return v;
	
#define SYSCALL_POSTLUDE_NORETURN		\
	cbox.data = (char *)&callpack;		\
	cbox.size = sizeof(callpack);		\
	cbox.timeout = -1;			\
	queue_write(callq, &cbox);

static int _zx_syscall0(sys_no)
int sys_no;
{
	SYSCALL_PRELUDE(sys_no)
	SYSCALL_POSTLUDE
}


static int _zx_syscall1(sys_no, a1)
int sys_no;
int a1;
{
	SYSCALL_PRELUDE(sys_no)
	SYSCALL_ARGSET(a1)
	SYSCALL_POSTLUDE
}

static int _zx_syscall2(sys_no, a1, a2)
int sys_no;
int a1;
int a2;
{
	SYSCALL_PRELUDE(sys_no)
	SYSCALL_ARGSET(a1)
	SYSCALL_ARGSET(a2)
	SYSCALL_POSTLUDE
}

static int _zx_syscall3(sys_no, a1, a2, a3)
int sys_no;
int a1;
int a2;
int a3;
{
	SYSCALL_PRELUDE(sys_no)
	SYSCALL_ARGSET(a1)
	SYSCALL_ARGSET(a2)
	SYSCALL_ARGSET(a3)
	SYSCALL_POSTLUDE
}

static int _zx_syscall4(sys_no, a1, a2, a3, a4)
int sys_no;
int a1;
int a2;
int a3;
int a4;
{
	SYSCALL_PRELUDE(sys_no)
	SYSCALL_ARGSET(a1)
	SYSCALL_ARGSET(a2)
	SYSCALL_ARGSET(a3)
	SYSCALL_ARGSET(a4)
	SYSCALL_POSTLUDE
}


static int _zx_syscall5(sys_no, a1, a2, a3, a4, a5)
int sys_no;
int a1;
int a2;
int a3;
int a4;
int a5;
{
	SYSCALL_PRELUDE(sys_no)
	SYSCALL_ARGSET(a1)
	SYSCALL_ARGSET(a2)
	SYSCALL_ARGSET(a3)
	SYSCALL_ARGSET(a4)
	SYSCALL_ARGSET(a5)
	SYSCALL_POSTLUDE
}

static void _zx_syscall_noret1(sys_no, a1)
int sys_no;
int a1;
{
	SYSCALL_PRELUDE(sys_no)
	SYSCALL_ARGSET(a1)
	SYSCALL_POSTLUDE_NORETURN
}

#define ZX_SYSCALL_DEF(name, sys_no) \
	int name (a1,a2,a3,a4,a5) \
	int a1,a2,a3,a4,a5; \
	{\
		return _zx_syscall5(sys_no, a1,a2,a3,a4,a5); \
	}

//--------------------------------------------------------------------------

//ZX_SYSCALL_DEF(	_zx_setup,	__NR_setup	)	//0
//ZX_SYSCALL_DEF(	_zx_exit,	__NR_exit	)	//1
ZX_SYSCALL_DEF(		_zx_fork,	__NR_fork	)	//2
//ZX_SYSCALL_DEF(	_zx_read,	__NR_read	)	//3
//ZX_SYSCALL_DEF(	_zx_write,	__NR_write	)	//4
ZX_SYSCALL_DEF(		_zx_open,	__NR_open	)	//5
ZX_SYSCALL_DEF(		_zx_close,	__NR_close	)	//6
//ZX_SYSCALL_DEF(	_zx_waitpid,	__NR_waitpid	)	//7
ZX_SYSCALL_DEF(		_zx_creat,	__NR_creat	)	//8
ZX_SYSCALL_DEF(		_zx_link,	__NR_link	)	//9
ZX_SYSCALL_DEF(		_zx_unlink,	__NR_unlink	)	//10
//ZX_SYSCALL_DEF(	_zx_execve,	__NR_execve	)	//11
ZX_SYSCALL_DEF(		_zx_chdir,	__NR_chdir	)	//12
//ZX_SYSCALL_DEF(	_zx_time,	__NR_time	)	//13
ZX_SYSCALL_DEF(		_zx_mknod,	__NR_mknod	)	//14
ZX_SYSCALL_DEF(		_zx_chmod,	__NR_chmod	)	//15
ZX_SYSCALL_DEF(		_zx_lchown,	__NR_lchown	)	//16

//ZX_SYSCALL_DEF(	_zx_break,	__NR_break	)	//17
//ZX_SYSCALL_DEF(	_zx_oldstat,	__NR_oldstat	)	//18

ZX_SYSCALL_DEF(		_zx_lseek,	__NR_lseek	)	//19
ZX_SYSCALL_DEF(		_zx_getpid,	__NR_getpid	)	//20
ZX_SYSCALL_DEF(		_zx_mount,	__NR_mount	)	//21
// ZX_SYSCALL_DEF(	_zx_oldmount,	__NR_oldumount	)	//22
ZX_SYSCALL_DEF(		_zx_setuid,	__NR_setuid	)	//23
ZX_SYSCALL_DEF(		_zx_getuid,	__NR_getuid	)	//24

ZX_SYSCALL_DEF(		_zx_ptrace,	__NR_ptrace	)	//26
ZX_SYSCALL_DEF(		_zx_alarm,	__NR_alarm	)	//27

ZX_SYSCALL_DEF(		_zx_pause,	__NR_pause	)	//29

ZX_SYSCALL_DEF(		_zx_access,	__NR_access	)	//33
ZX_SYSCALL_DEF(		_zx_nice,	__NR_nice	)	//34
ZX_SYSCALL_DEF(		_zx_sync,	__NR_sync	)	//36
ZX_SYSCALL_DEF(		_zx_kill,	__NR_kill	)	//37
ZX_SYSCALL_DEF(		_zx_rename,	__NR_rename	)	//38
ZX_SYSCALL_DEF(		_zx_mkdir,	__NR_mkdir	)	//39
ZX_SYSCALL_DEF(		_zx_rmdir,	__NR_rmdir	)	//40
ZX_SYSCALL_DEF(		_zx_dup,	__NR_dup	)	//41

// ZX_SYSCALL_DEF(	_zx_brk,	__NR_brk	)	//45

ZX_SYSCALL_DEF(		_zx_setgid,	__NR_setgid	)	//46
ZX_SYSCALL_DEF(		_zx_getgid,	__NR_getgid	)	//47
ZX_SYSCALL_DEF(		_zx_signal,	__NR_signal	)	//48
ZX_SYSCALL_DEF(		_zx_geteuid,	__NR_geteuid	)	//49
ZX_SYSCALL_DEF(		_zx_getegid,	__NR_getegid	)	//50
ZX_SYSCALL_DEF(		_zx_acct,	__NR_acct	)	//51
ZX_SYSCALL_DEF(		_zx_umount,	__NR_umount	)	//52
				/* recycled never used phys() */

//ZX_SYSCALL_DEF(	_zx_lock,	__NR_lock	)	//53

ZX_SYSCALL_DEF(		_zx_ioctl,	__NR_ioctl	)	//54
ZX_SYSCALL_DEF(		_zx_fcntl,	__NR_fcntl	)	//55

//ZX_SYSCALL_DEF(	_zx_mpx,	__NR_mpx	)	//56

ZX_SYSCALL_DEF(		_zx_setpgid,	__NR_setpgid	)	//57

//ZX_SYSCALL_DEF(	_zx_ulimit	,__NR_ulimit	)	//58
//ZX_SYSCALL_DEF(	_zx_oldolduname	,__NR_oldolduname)	//59

ZX_SYSCALL_DEF(		_zx_umask,	__NR_umask	)	//60
ZX_SYSCALL_DEF(		_zx_chroot,	__NR_chroot	)	//61

//ZX_SYSCALL_DEF(	_zx_ustat	,__NR_ustat	)	//62

ZX_SYSCALL_DEF(		_zx_dup2,	__NR_dup2	)	//63
ZX_SYSCALL_DEF(		_zx_getppid,	__NR_getppid	)	//64
ZX_SYSCALL_DEF(		_zx_getpgrp,	__NR_getpgrp	)	//65
ZX_SYSCALL_DEF(		_zx_setsid,	__NR_setsid	)	//66

//ZX_SYSCALL_DEF(	_zx_sigaction	,__NR_sigaction	)	//67

ZX_SYSCALL_DEF(		_zx_sgetmask,	__NR_sgetmask	)	//68
ZX_SYSCALL_DEF(		_zx_ssetmask,	__NR_ssetmask	)	//69
ZX_SYSCALL_DEF(		_zx_setreuid,	__NR_setreuid	)	//70
ZX_SYSCALL_DEF(		_zx_setregid,	__NR_setregid	)	//71

//ZX_SYSCALL_DEF(	_zx_sigsuspend	,__NR_sigsuspend)	//72
//ZX_SYSCALL_DEF(	_zx_sigpending	,__NR_sigpending)	//73

ZX_SYSCALL_DEF(		_zx_sethostname,__NR_sethostname)	//74

//ZX_SYSCALL_DEF(	_zx_setrlimit	,__NR_setrlimit	)	//75
//ZX_SYSCALL_DEF(	_zx_getrlimit	,__NR_getrlimit	)	//76
//ZX_SYSCALL_DEF(	_zx_getrusage	,__NR_getrusage	)	//77
//ZX_SYSCALL_DEF(	_zx_gettimeofday,__NR_gettimeofday)	//78
//ZX_SYSCALL_DEF(	_zx_settimeofday,__NR_settimeofday)	//79
//ZX_SYSCALL_DEF(	_zx_getgroups,	__NR_getgroups	)	//80
//ZX_SYSCALL_DEF(	_zx_setgroups,	__NR_setgroups	)	//81
//ZX_SYSCALL_DEF(	_zx_select,	__NR_select	)	//82

ZX_SYSCALL_DEF(		_zx_symlink,	__NR_symlink	)	//83

//ZX_SYSCALL_DEF(	_zx_oldlstat,	__NR_oldlstat	)	//84
//ZX_SYSCALL_DEF(	_zx_readlink,	__NR_readlink	)	//85

ZX_SYSCALL_DEF(		_zx_uselib,	__NR_uselib	)	//86
ZX_SYSCALL_DEF(		_zx_swapon,	__NR_swapon	)	//87
ZX_SYSCALL_DEF(		_zx_reboot,	__NR_reboot	)	//88

//ZX_SYSCALL_DEF(	_zx_readdir,	__NR_readdir	)	//89

ZX_SYSCALL_DEF(		_zx_mmap,	__NR_mmap	)	//90
ZX_SYSCALL_DEF(		_zx_munmap,	__NR_munmap	)	//91
ZX_SYSCALL_DEF(		_zx_truncate,	__NR_truncate	)	//92
ZX_SYSCALL_DEF(		_zx_ftruncate,	__NR_ftruncate	)	//93
ZX_SYSCALL_DEF(		_zx_fchmod,	__NR_fchmod	)	//94
ZX_SYSCALL_DEF(		_zx_fchown,	__NR_fchown	)	//95
ZX_SYSCALL_DEF(		_zx_getpriority,__NR_getpriority)	//96
ZX_SYSCALL_DEF(		_zx_setpriority,__NR_setpriority)	//97

//ZX_SYSCALL_DEF(	,		__NR_profil	)	//98
//ZX_SYSCALL_DEF(	,		__NR_statfs	)	//99
//ZX_SYSCALL_DEF(	,		__NR_fstatfs	)	//100
//ZX_SYSCALL_DEF(	,		__NR_ioperm	)	//101

ZX_SYSCALL_DEF(		_zx_socketcall,	__NR_socketcall	)	//102
ZX_SYSCALL_DEF(		_zx_syslog,	__NR_syslog	)	//103

//ZX_SYSCALL_DEF(	,		__NR_setitimer	)	//104
//ZX_SYSCALL_DEF(	,		__NR_getitimer	)	//105
//ZX_SYSCALL_DEF(	?,		__NR_newstat	)	//106
//ZX_SYSCALL_DEF(	?,		__NR_newlstat	)	//107
//ZX_SYSCALL_DEF(	?,		__NR_newfstat	)	//

//ZX_SYSCALL_DEF(	_zx_fstat,	__NR_fstat	)	//108
//ZX_SYSCALL_DEF(	_zx_olduname,	__NR_olduname	)	//109
//ZX_SYSCALL_DEF(	_zx_iopl,	__NR_iopl	)	//110

ZX_SYSCALL_DEF(		_zx_vhangup,	__NR_vhangup	)	//111

//ZX_SYSCALL_DEF(	_zx_idle,	__NR_idle	)	//112
//ZX_SYSCALL_DEF(	_zx_vm86old,	__NR_vm86old	)	//113
//ZX_SYSCALL_DEF(	_zx_wait4,	__NR_wait4	)	//114

ZX_SYSCALL_DEF(		_zx_swapoff,	__NR_swapoff	)	//115

//ZX_SYSCALL_DEF(	_zx_sysinfo,	__NR_sysinfo	)	//116

ZX_SYSCALL_DEF(		_zx_ipc,	__NR_ipc	)	//117
ZX_SYSCALL_DEF(		_zx_fsync,	__NR_fsync	)	//118
ZX_SYSCALL_DEF(		_zx_sigreturn,	__NR_sigreturn	)	//119
ZX_SYSCALL_DEF(		_zx_clone,	__NR_clone	)	//120
ZX_SYSCALL_DEF(		_zx_setdomainname,__NR_setdomainname)	//121

// ZX_SYSCALL_DEF(	_zx_uname,	__NR_uname	)	//122
/* ZX_SYSCALL_DEF(	?,		__NR_newuname	) */
// ZX_SYSCALL_DEF(	_zx_modify_ldt,	__NR_modify_ldt	)	//123

//ZX_SYSCALL_DEF(	_zx_adjtimex,	__NR_adjtimex	)	//124

ZX_SYSCALL_DEF(		_zx_mprotect,	__NR_mprotect	)	//125

//ZX_SYSCALL_DEF(	_zx_sigprocmask,__NR_sigprocmask)	//126

ZX_SYSCALL_DEF(		_zx_create_module,__NR_create_module)	//127
ZX_SYSCALL_DEF(		_zx_init_module,__NR_init_module)	//128
ZX_SYSCALL_DEF(		_zx_delete_module,__NR_delete_module)	//129
ZX_SYSCALL_DEF(		_zx_get_kernel_syms,__NR_get_kernel_syms)//130
ZX_SYSCALL_DEF(		_zx_quotactl,	__NR_quotactl	)	//131
ZX_SYSCALL_DEF(		_zx_getpgid,	__NR_getpgid	)	//132
ZX_SYSCALL_DEF(		_zx_fchdir,	__NR_fchdir	)	//133
ZX_SYSCALL_DEF(		_zx_bdflush,	__NR_bdflush	)	//134
ZX_SYSCALL_DEF(		_zx_sysfs,	__NR_sysfs	)	//135
ZX_SYSCALL_DEF(		_zx_personality,__NR_personality)	//136

//ZX_SYSCALL_DEF(	_zx_afs_syscall,__NR_afs_syscall)	//137

ZX_SYSCALL_DEF(		_zx_setfsuid,	__NR_setfsuid	)	//138
ZX_SYSCALL_DEF(		_zx_setfsgid,	__NR_setfsgid	)	//139
ZX_SYSCALL_DEF(		_zx_llseek,	__NR__llseek	)	//140

//ZX_SYSCALL_DEF(	_zx_getdents,	__NR_getdents	)	//141
//ZX_SYSCALL_DEF(	_zx__newselect,	__NR__newselect	)	//142

ZX_SYSCALL_DEF(		_zx_flock,	__NR_flock	)	//143
ZX_SYSCALL_DEF(		_zx_msync,	__NR_msync	)	//144

//ZX_SYSCALL_DEF(	_zx_readv,	__NR_readv	)	//145
//ZX_SYSCALL_DEF(	_zx_writev,	__NR_writev	)	//146

ZX_SYSCALL_DEF(		_zx_getsid,	__NR_getsid	)	//147
ZX_SYSCALL_DEF(		_zx_fdatasync,	__NR_fdatasync	)	//148
// ZX_SYSCALL_DEF(	_zx_sysctl,	__NR_sysctl	)	//149
ZX_SYSCALL_DEF(		_zx_mlock,	__NR_mlock	)	//150
ZX_SYSCALL_DEF(		_zx_munlock,	__NR_munlock	)	//151
ZX_SYSCALL_DEF(		_zx_mlockall,	__NR_mlockall	)	//152
ZX_SYSCALL_DEF(		_zx_munlockall,	__NR_munlockall	)	//153

#if 1
ZX_SYSCALL_DEF(	_zx_sched_setparam,	__NR_sched_setparam)	//154
ZX_SYSCALL_DEF(	_zx_sched_getparam,	__NR_sched_getparam)	//155
ZX_SYSCALL_DEF(	_zx_sched_setscheduler,	__NR_sched_setscheduler)//156
ZX_SYSCALL_DEF(	_zx_sched_getscheduler,	__NR_sched_getscheduler)//157
ZX_SYSCALL_DEF(	_zx_sched_yield,	__NR_sched_yield)	//158
ZX_SYSCALL_DEF(	_zx_sched_get_priority_max,__NR_sched_get_priority_max)//159
ZX_SYSCALL_DEF(	_zx_sched_get_priority_min,__NR_sched_get_priority_min)//160
ZX_SYSCALL_DEF(	_zx_sched_rr_get_interval,__NR_sched_rr_get_interval)//161
#endif

ZX_SYSCALL_DEF(		_zx_nanosleep,	__NR_nanosleep	)	//162
ZX_SYSCALL_DEF(		_zx_mremap,	__NR_mremap	)	//163
ZX_SYSCALL_DEF(		_zx_setresuid,	__NR_setresuid	)	//164
ZX_SYSCALL_DEF(		_zx_getresuid,	__NR_getresuid	)	//165

//ZX_SYSCALL_DEF(	_zx_vm86,	__NR_vm86	)	//166

ZX_SYSCALL_DEF(		_zx_query_module,__NR_query_module)	//167

//ZX_SYSCALL_DEF(	_zx_poll,	__NR_poll	)	//168
//ZX_SYSCALL_DEF(	_zx_nfsservctl,	__NR_nfsservctl	)	//169

ZX_SYSCALL_DEF(		_zx_setresgid,	__NR_setresgid	)	//170
ZX_SYSCALL_DEF(		_zx_getresgid,	__NR_getresgid	)	//171

ZX_SYSCALL_DEF(		_zx_prctl,	__NR_prctl	)	//172
#if 0
ZX_SYSCALL_DEF(		?,		__NR_rt_sigreturn)	//173
ZX_SYSCALL_DEF(		?,		__NR_rt_sigaction)	//174
ZX_SYSCALL_DEF(		?,		__NR_rt_sigprocmask)	//175
ZX_SYSCALL_DEF(		?,		__NR_rt_sigpending)	//176
ZX_SYSCALL_DEF(		?,		__NR_rt_sigtimedwait)	//177
ZX_SYSCALL_DEF(		?,		__NR_rt_sigqueueinfo)	//178
ZX_SYSCALL_DEF(		?,		__NR_rt_sigsuspend)	//179
ZX_SYSCALL_DEF(		?,		__NR_pread	)	//180
ZX_SYSCALL_DEF(		?,		__NR_pwrite	)	//181
#endif

ZX_SYSCALL_DEF(		_zx_chown,	__NR_chown	)	//182
ZX_SYSCALL_DEF(		_zx_getcwd,	__NR_getcwd	)	//183
#if 0
ZX_SYSCALL_DEF(		?,		__NR_capget	)	//184
ZX_SYSCALL_DEF(		?,		__NR_capset	)	//185
ZX_SYSCALL_DEF(		?,		__NR_sigaltstack)	//186
#endif

ZX_SYSCALL_DEF(		_zx_sendfile,	__NR_sendfile	)	//187

//ZX_SYSCALL_DEF(	_zx_streams1,	__NR_streams1	)	//188
//ZX_SYSCALL_DEF(	_zx_streams2,	__NR_streams2	)	//189

//ZX_SYSCALL_DEF(	_zx_vfork0,	__NR_vfork	)	//190


#if 00
ZX_SYSCALL_DEF(		_zx_socket,	__NR_socket	) /* 200 */
ZX_SYSCALL_DEF(		_zx_bind,	__NR_bind	)
ZX_SYSCALL_DEF(		_zx_connect,	__NR_connect	)
ZX_SYSCALL_DEF(		_zx_accept,	__NR_accept	)
ZX_SYSCALL_DEF(		_zx_listen,	__NR_listen	)
/*
ZX_SYSCALL_DEF(		_zx_ppp_connect,__NR_ppp_connect)
ZX_SYSCALL_DEF(		_zx_ppp_disconnect,__NR_ppp_disconnect)
ZX_SYSCALL_DEF(		_zx_ppp_cleanup,__NR_ppp_cleanup)
*/
#endif

//--------------------------------------------------------------------------


extern void kaku(const char*,...);

static void (*handlers[32])(int);

// extern void alm(int);

#if 0
static void dbg_wpr(int num)
{
  register int i;
  for (i = 0; i < 16; i++){
    dbg_regs[i] = num;
  }
  
  handler_wrapper(num);
}
#else
void dbg_wpr(int num);

asm("
	.align 4
	.type	 _dbg_wpr,@function
_dbg_wpr:
	mov.l	r15, @-r15
	mov.l	r14, @-r15
	mov.l	r13, @-r15
	mov.l	r12, @-r15
	mov.l	r11, @-r15
	mov.l	r10, @-r15
	mov.l	r9, @-r15
	mov.l	r8, @-r15
	mov.l	r7, @-r15
	mov.l	r6, @-r15
	mov.l	r5, @-r15
	mov.l	r4, @-r15
	mov.l	r3, @-r15
	mov.l	r2, @-r15
	mov.l	r1, @-r15
	mov.l	r0, @-r15

	mov.l	DbgRegs, r2
	mov	#16, r3

	.align 2
1:	
	mov.l	@r15, r8
	mov.l	r8, @r2
	dt	r3
	add	#4, r15
	bf.s	1b
	add	#4, r2
	
	mov.l	HandlerWrapper, r1
	jsr	@r1
	nop

	.align 4
DbgRegs:
	.long	_dbg_regs
HandlerWrapper:
	.long	_handler_wrapper
_dbg_wpr_end:
	.size	 _dbg_wpr, _dbg_wpr_end-_dbg_wpr
");
#endif

#if 0
static void handler_wrapper(int num)
{
//	alm(num);
	(*handlers[1])(num);
	sigreturn(num);
}

#else
void handler_wrapper(int);
asm("
	.align 4
	.type	 _handler_wrapper,@function
_handler_wrapper:
	mov	r15, r1
	mov.l	r8, @-r15
	mov.l	r9, @-r15
	mov.l	r14, @-r15
	sts.l	pr,@-r15

	mov	r1, r9		"/*  r9: saved SP (frame) */"
	mov	r4, r8		"/*  r8: signal no */"

	mov.l	Handlers, r1
	mov	r8, r0
	shll2	r0
	mov.l	@(r0,r1), r1
	jsr	@r1
	mov	r15,r14

	mov.l	SigRet,r1
	jsr	@r1
	mov	r9,r4

	.align 4
Handlers:
	.long	_handlers
SigRet:
	.long	_sigreturn
_handler_wrapper_end:
	.size	 _handler_wrapper,_handler_wrapper_end-_handler_wrapper
"
);
#endif

#if 0
int signal(int num, void (*handler)(int))
{
	handlers[num] = handler;
	return _zx_syscall2(__NR_signal, num, handler_wrapper);
}
#endif

#if 0
void check(){
	int **a;
	
	a = (int**) &a;
	kaku ("%p: %p %p %p %p %p %p %p", a, a[0], a[1], a[2], a[3], a[5], a[6]);
}
#endif


int _zx_regbuf[16];

#if 0
int _exit(a1)
{
	return _QUIT(a1);
}
#endif

//--------------------------------------------------------------------------

void
_zx_exit( a1 )
int	a1;
{
	int	pid;
	/*
	 *  If child process failed to execve and call exit,
	 *  the return value is the process no of child process.
	 *  We must return from *VFORK* with this value.
	 *    - exit system call always returns a retval.
	 */
	pid= _zx_syscall1( __NR_exit, a1 );
	if( pid > 0 ){
//		longjmp(_zx_regbuf, pid);
	}
}


int
_zx_exit1( a1 )
int	a1;
{
	int	pid;
	/*
	 *  If child process failed to execve and call exit,
	 *  the return value is the process no of child process.
	 *  We must return from *VFORK* with this value.
	 *    - exit system call always returns a retval.
	 */
	pid= _zx_syscall1( __NR_exit, a1 );
	if( pid > 0 ){
//		longjmp(_zx_regbuf, pid);
	}
	return	pid;
}


int
_zx_read( a1, a2, a3 )
int	a1;
char	*a2;
int	a3;
{
	char	*p= a2;
	char	*e= a2 + a3;

	if( a3 > 0 ){
		ZX_TOUCH( p );
		ZX_TOUCH( e-1 );
		while( (p += ZX_PAGE_SIZE) < e ){
	   		ZX_TOUCH( e-1 );
		}
	}
	return	_zx_syscall3( __NR_read, a1, a2, a3 );
}

int
_zx_write( a1, a2, a3 )
int	a1;
char	*a2;
int	a3;
{
	char	*p= a2;
	char	*e= a2 + a3;

	if( a3 > 0 ){
		ZX_TOUCH(p);
		ZX_TOUCH(e-1);
		while( (p += ZX_PAGE_SIZE) < e ){
	   		ZX_TOUCH(e-1);
		}
	}
	return	_zx_syscall3( __NR_write, a1, a2, a3 );
}


int
_zx_waitpid( pid, stat, options )
pid_t	pid;
int	*stat;
int	options;
{
	ZX_TOUCH(stat);
	return	_zx_syscall3( __NR_waitpid, pid, stat, options );
}


time_t
_zx_time( tloc )
time_t	*tloc;
{
	ZX_ZS_TOUCH( tloc );
	return	(time_t)_zx_syscall1( __NR_time, tloc );
}

int
_zx_stime( tloc )
time_t	*tloc;
{
	ZX_S_TOUCH(tloc);
	return	_zx_syscall1( __NR_stime, tloc );
}

int
_zx_utime( path, times )
char	*path;
struct utimbuf	*times;
{
	ZX_S_TOUCH(times);
	return	_zx_syscall2( __NR_utime, path, times );
}

int
_zx_pipe( files )
int	files[2];
{
	ZX_TOUCH(&files[0]);
	ZX_TOUCH(&files[1]);
	return	_zx_syscall1( __NR_pipe, files );
}

clock_t
_zx_times( buf )
struct tms	*buf;
{
	ZX_S_TOUCH(buf);
	return	_zx_syscall1( __NR_times, buf );
}

int
_zx_ustat( dev, buf )
int	dev;
struct ustat	*buf;
{
	ZX_S_TOUCH(buf);
	return	_zx_syscall2( __NR_ustat, dev, buf );
}


int
_zx_sigaction( sig, act, oact )
int	sig;
struct sigaction	*act;
struct sigaction	*oact;
{
	if( act ){
		ZX_S_TOUCH(act);
	}
	if( oact ){
		ZX_S_TOUCH(oact);
	}
	return	_zx_syscall3( __NR_sigaction, sig, act, oact );
}

int
_zx_sigsuspend( set )
sigset_t	*set;
{
	ZX_S_TOUCH(set);
	return	_zx_syscall1(__NR_sigsuspend, set);
}


int
_zx_sigpending( set )
sigset_t	*set;
{
	ZX_S_TOUCH(set);
	return	_zx_syscall1(__NR_sigpending, set);
}


int
_zx_setrlimit( res, rlp )
int	res;
struct rlimit	*rlp;
{
	ZX_S_TOUCH(rlp);
	return	_zx_syscall2(__NR_setrlimit, res, rlp);
}

int
_zx_getrlimit( res, rlp )
int	res;
struct rlimit	*rlp;
{
	ZX_S_TOUCH(rlp);
	return	_zx_syscall2(__NR_getrlimit, res, rlp);
}


int
_zx_getrusage( who, usage )
int	who;
struct rusage	*usage;
{
	ZX_S_TOUCH(usage);
	return	_zx_syscall2(__NR_getrusage, who, usage);
}


int
_zx_gettimeofday( tv, tz )
struct timeval	*tv;
struct timezone	*tz;
{
	if( tv ){
		ZX_S_TOUCH(tv);
	}
	if( tz ){
		ZX_S_TOUCH(tz);
	}
	return	_zx_syscall2(__NR_gettimeofday, tv, tz);
}


int
_zx_settimeofday( tv, tz )
struct timeval	*tv;
struct timezone	*tz;
{
	if( tv ){
		ZX_S_TOUCH(tv);
	}
	if( tz ){
		ZX_S_TOUCH(tz);
	}
	return _zx_syscall2(__NR_settimeofday, tv, tz);
}


int
_zx_getgroups( size, list )
int	size;
gid_t	list[];
{
	if( list ){
		ZX_TOUCH(list);
		if( size > 0 ){
			ZX_TOUCH((char *)(&list[size])-1);
		}
		/* NOTE: we assume the size of list is less than page size. */
	}
	return	_zx_syscall2( __NR_getgroups, size, list );
}

int
_zx_setgroups( size, list )
int	size;
gid_t	list[];
{
	if( list ){
		ZX_TOUCH(list);
		if( size > 0 ){
			ZX_TOUCH((char *)(&list[size])-1);
		}
		/* NOTE: we assume the size of list is less than page size. */
	}
	return	_zx_syscall2(__NR_setgroups,size,list);
}


int
_zx_select( n, rfs, wfs, efs, tout )
int	n;
fd_set	*rfs;
fd_set	*wfs;
fd_set	*efs;
struct timeval	*tout;
{
	int	sz= (n + 7)/8 - 1;

	if( rfs ){
		ZX_TOUCH(rfs);
		if( sz > 0 ){
			ZX_TOUCH((char *)rfs + sz-1);
		}
	}
	if( wfs ){
		ZX_TOUCH(wfs);
		if( sz > 0 ){
			ZX_TOUCH((char *)wfs + sz-1);
		}
	}
	if( efs ){
		ZX_TOUCH(efs);
		if( sz > 0 ){
			ZX_TOUCH((char *)efs + sz-1);
		}
	}
	ZX_S_TOUCH(tout);
	return	_zx_syscall5(__NR_select, n, rfs, wfs, efs, tout);
}


int
_zx_readlink(path, buf, size)
char	*path;
char	*buf;
int	size;
{
	char	*p= buf;
	char	*e= buf + size;

	if( size > 0 ){
		ZX_TOUCH(p);
		ZX_TOUCH(e-1);
		while( (p += ZX_PAGE_SIZE) < e ){
	   		ZX_TOUCH(e-1);
		}
	}
	return	_zx_syscall3(__NR_readlink, path, buf, size);
}


int
_zx_readdir( fd, dirent, n )
int	fd;
struct dirent	*dirent;
int	n;
{
	char	*p= (char *)dirent;
	char	*e= p + n;

	if( n > 0 ){
		ZX_TOUCH(p);
		ZX_TOUCH(e-1);
		while ((p += ZX_PAGE_SIZE) < e) {
	   		ZX_TOUCH(p);
		}
	}
	return	_zx_syscall3(__NR_readdir, fd, dirent, n);
}

int
_zx_getdents( fd, dirent, n)
int	fd;
struct dirent	*dirent;
int	n;
{
#if 0 /* wakaran */
	char *p = (char *)dirent;
	char *e = (char *)(dirent + n);
#else
	char *p = (char *)dirent;
	char *e = (char *)dirent + n;
#endif

	if( n > 0 ){
		ZX_TOUCH(p);
		ZX_TOUCH(e-1);
		while( (p += ZX_PAGE_SIZE) < e ){
	   		ZX_TOUCH(e-1);
		}
	}
	return	_zx_syscall3(__NR_getdents, fd, dirent, n);
}


int
_zx_statfs( path, buf )
char	*path;
struct statfs	*buf;
{
	ZX_S_TOUCH( buf );
	return	_zx_syscall2(__NR_statfs, path, buf);
}

int
_zx_fstatfs( fd, buf )
int	fd;
struct statfs	*buf;
{
	ZX_S_TOUCH(buf);
	return	_zx_syscall2(__NR_fstatfs, fd, buf);
}


int
_zx_setitimer( which, val, oval)
int	which;
struct itimerval	*val;
struct itimerval	*oval;
{
	if( val ){
		ZX_S_TOUCH(val);
	}
	if( oval ){
		ZX_S_TOUCH(oval);
	}
	return	_zx_syscall3(__NR_setitimer, which, val, oval);
}

int
_zx_getitimer( which, val)
int	which;
struct itimerval	*val;
{
	if( val ){
		ZX_S_TOUCH(val);
	}
	return	_zx_syscall2(__NR_getitimer, which, val);
}


int
_zx_stat(path, buf)
char	*path;
struct stat	*buf;
{
	ZX_TOUCH(buf);
	return	_zx_syscall2(__NR_stat, path, buf);
}

int
_zx_lstat(path, buf)
char	*path;
struct stat	*buf;
{
	ZX_TOUCH(buf);
	return	_zx_syscall2(__NR_lstat, path, buf);
}

static void
write1s( char *s )
{
	char	*p;
	for( p= s ; *p != 0 ; ++p );
	_zx_syscall3( __NR_write, 1, s, p-s );
}

int
_zx___lxstat( ver, path, buf )
int	ver;
char	*path;
struct stat	*buf;
{
	ZX_TOUCH( buf );
	write1s( path );
	_zx_syscall2(__NR_lstat, path, buf);
	return	0;
}

int
_zx___xstat( ver, path, buf )
int	ver;
char	*path;
struct stat	*buf;
{
	ZX_TOUCH(buf);
	write1s(path);
	_zx_syscall2(__NR_stat, path, buf);
	return	0;
}

int
_zx_fstat( fd, buf )	//108
int		fd;
struct stat	*buf;
{
	ZX_TOUCH(buf);
	return	_zx_syscall2( __NR_fstat, fd, buf);
}


int
_zx_wait4(pid, status, options, rusage)	//114
int		pid;
int		*status;
int		options;
struct rusage	*rusage;
{
	if( status ){
		ZX_TOUCH(status);
	}
	if( rusage ){
		ZX_S_TOUCH(rusage);
	}
	return _zx_syscall4(__NR_wait4, pid, status, options, rusage);
}

int
_zx_sysinfo( info )	//116
struct sysinfo	*info;
{
	ZX_S_TOUCH(info);
	return	_zx_syscall1(__NR_sysinfo, info);
}

int
_zx_uname( buf )	//122
struct old_utsname	*buf;
{
	ZX_S_TOUCH(buf);
	return _zx_syscall1(__NR_uname, buf);
}


int
_zx_adjtimex( buf )	//124
struct timex	*buf;
{
	ZX_S_TOUCH(buf);
	return	_zx_syscall1(__NR_adjtimex, buf);
}


int
_zx_sigprocmask(how, set, oset)	//126
int how;
sigset_t *set;
sigset_t *oset;
{
	if( set ){
		ZX_S_TOUCH(set);
	}
	if( oset ){
		ZX_S_TOUCH(oset);
	}
	return _zx_syscall3(__NR_sigprocmask, how, set, oset);
}

int
_zx_readv(fd, iov, n)	//145
int fd;
struct iovec *iov;
int n;
{
	int i;
	int l, sz;
	char *b;

	n--;
	for (i = 0; i < n; i++) {
		b = iov[i].iov_base;
		sz = iov[i].iov_len;
		while (sz > 0) {
			l = _zx_read(fd, b, sz);
			if (l <= 0)
				return l;
			sz -= l;
			b += l;
		}
	}
	return _zx_read(fd, iov[i].iov_base, iov[i].iov_len);
}


int
_zx_writev(fd, iov, n)	//146
int fd;
struct iovec *iov;
int n;
{
	int i;
	int l, sz;
	char *b;

	n--;
	for (i = 0; i < n; i++) {
		b = iov[i].iov_base;
		sz = iov[i].iov_len;
		while (sz > 0) {
			l= _zx_write(fd, b, sz);
			if (l <= 0)
				return l;
			sz -= l;
			b += l;
		}
	}
	return	_zx_write(fd, iov[i].iov_base, iov[i].iov_len);
}


int
_zx_poll(fds, nfds, timeout)	//168
struct pollfd *fds;
int nfds;
int timeout;
{
	if (nfds > 0) {
		ZX_TOUCH(fds);
		ZX_TOUCH((char *)&fds[nfds] - 1);
	}
	return _zx_syscall3(__NR_poll, fds, nfds, timeout);
}


int
_zx_nfsservctl(cmd, arg, res)	//169
int		cmd;
struct nfsctl_arg *arg;
union nfsctl_res *res;
{
	ZX_S_TOUCH(arg);
	ZX_S_TOUCH(res);
	return _zx_syscall3(__NR_nfsservctl, cmd, arg, res);
}

#define kaku(...) 

/*
 * sys_vfork saves a stack area from a arg sp to a real sp
 */
int _vfork0 (void* sp){
//	return _zx_syscall1(__NR_vfork, sp);

	OBJECT_NAME callq, retq, name; 
	QUEUE_PBOX cbox, rbox; 
	struct zx_syscall callpack; 
	struct zx_sysret retpack; 
	int v; 
	callq = ((name = self_getname()) & 0xffff) | 0x4c430000; 
	retq = (name & 0xffff) | 0x4c520000; 
	callpack.sys_no = __NR_vfork;
	callpack.a1 = (unsigned long)sp;
	cbox.data = (char *)&callpack; 
	cbox.size = sizeof(callpack); 
	cbox.timeout = -1; 
	queue_write(callq, &cbox); 
retry: 
	retpack.retval = 0; 
	retpack.status = ZX_SYSCALL_STAT_INVAL; 
	rbox.data = (char *)&retpack; 
	rbox.size = sizeof(retpack); 
	rbox.timeout = -1; 
	queue_read(retq, &rbox); 
//	kaku("vfork ret = %p status = %p\n", retpack.retval, retpack.status);
	if (retpack.status == ZX_SYSCALL_STAT_INVAL){ 
		goto retry; 
	} 
     	v = retpack.retval; 
	if (v < 0) { 
		errno = -v; 
		v = -1; 
	} 
	return v;
}

#if 0
int vfork(void)
{
	int dummy = 0x123456;
	int ret;
	kaku ("dummy = %p\n", &dummy);
	ret = _vfork0(&dummy);
	kaku ("dummy = %p, ret = %d\n", dummy, ret);
	kaku ("ret to %p\n", __builtin_return_address(0));
	return ret;
}
#elif 0
int vfork(void)
{
	int dummy;
	return  _vfork0(&dummy);
}
#elif 1
asm("
	.align 4
	.global	_vfork
	.type	 _vfork,@function
_vfork:
	mov.l	Vfork0,r1
	sts.l	pr,@-r15
	jsr	@r1
	mov	r15, r4
	lds.l	@r15+,pr
	rts	
	nop
.LX1031:
	.align 2
Vfork0:
	.long	__vfork0
vfork_end:
	.size	 _vfork,vfork_end-_vfork
");
#endif


int
_zx_execve( path, argv, envp )	//11
char	*path;
char	*argv[];
char	*envp[];
{
	int		pid;
	extern void	longjmp();

	if( (pid= _zx_syscall3( __NR_execve, path, argv, envp )) < 0 ){
		errno= -pid;
//		write(1, "exec failed", 11);
		return	-1;	/* execve failed */
	}else{
		_zx_write(1,"do longjmp",10);
//		longjmp(_zx_regbuf, pid);
	}
}


void *
_zx_brk( data )
void	*data;
{
#if 1234
        char    *oldbrk, *newbrk;
          /**/
        oldbrk= (char*)crystal_sbrk( 0 );
        newbrk= (char*)crystal_sbrk( (char*)data - oldbrk );
        if( newbrk == (char*)(-1) ){
                errno= 12/*ENOMEM*/;
                return (void*)(-1);
        }
        while( oldbrk < newbrk ){
                *oldbrk++ = 0;
        }
        return	(void*)0;
#else
        ZX_NZTOUCH(data);
        return _zx_syscall1(  __NR_brk , data);
#endif
}


#if 0	/* { */

/* need name string */
#define __NR_open		  5
#define __NR_creat		  8
#define __NR_link		  9
#define __NR_unlink		 10
#define __NR_chdir		 12
#define __NR_mknod		 14
#define __NR_chmod		 15
#define __NR_lchown		 16
#define __NR_mount		 21
#define __NR_access		 33
#define __NR_rename		 38
#define __NR_mkdir		 39
#define __NR_rmdir		 40
#define __NR_acct		 51
#define __NR_umount		 52
#define __NR_chroot		 61
#define __NR_sethostname	 74
#define __NR_symlink		 83
#define __NR_setdomainname	121
#define __NR_create_module	127
#define __NR_chown		182

/* we assume argv and envp arrays have pages */
#define __NR_execve		 11

/* name and stat buf */
#define __NR_oldstat		 18
#define __NR_oldfstat		 28

#define __NR_oldumount		 22


/* What are they? */
/* #define __NR_stty		 31	--> old, not implemented */
/* #define __NR_gtty		 32	--> old, not implemented */
/* #define __NR_ftime		 35	--> old, not implemented */
/* #define __NR_prof		 44	--> old, not implemented */
/* #define __NR_lock		 53	--> old, not implemented */
/* #define __NR_mpx		 56	--> old, not implemented */
/* #define __NR_oldolduname	 59	--> old, not implemented */
#define __NR_sgetmask		 68
#define __NR_ssetmask		 69


/* ioctl can have different typed arguments dependent on the request. */
#define __NR_ioctl		 54
#define __NR_fcntl		 55


#define __NR_oldlstat		 84
#define __NR_olduname		109


/* #define __NR_profil		 98	--> old, not implemented */

/* args are dependent on the socket system call */
#define __NR_socketcall		102

/* syslog read buf ? */
#define __NR_syslog		103

/* args are dependent on call (indirect call system V IPCs) */
#define __NR_ipc		117


/* pendings */
#define __NR_init_module	128
#define __NR_delete_module	129
#define __NR_bdflush		134
#define __NR_get_kernel_syms	130
#define __NR_sysfs		135
#define __NR__sysctl		149
#define __NR_sched_setparam		154
#define __NR_sched_getparam		155
#define __NR_sched_setscheduler		156
#define __NR_sched_getscheduler		157
#define __NR_sched_yield		158
#define __NR_sched_get_priority_max	159
#define __NR_sched_get_priority_min	160
#define __NR_sched_rr_get_interval	161
#define __NR_nanosleep		162
#define __NR_query_module	167
#define __NR_rt_sigreturn	173
#define __NR_rt_sigaction	174
#define __NR_rt_sigprocmask	175
#define __NR_rt_sigpending	176
#define __NR_rt_sigtimedwait	177
#define __NR_rt_sigqueueinfo	178
#define __NR_rt_sigsuspend	179

/* ? */
#define __NR_prctl              172
#define __NR_pread		180
#define __NR_pwrite		181
#define __NR_capget		184
#define __NR_capset		185
#define __NR_sigaltstack	186
#define __NR_sendfile		187

/* this C lib ? */
#define __NR_getcwd		183

#endif	/* } */

__xmknod()
{
	main();
}

int
sigreturn()
{
	return	0;
}

