// 2000/10/18 Ogasawara Hiroyuki

#ifndef	__ZXLSYSCALL_H__

#ifdef __cplusplus
extern "C" {
#endif

// Linux Includes
#if 0
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<fcntl.h>
#include	<utime.h>
#include	<unistd.h>
#include	<signal.h>
#include	<sys/wait.h>
#include	<net.h>
#else
#include	<linux/types.h>
#include	<linux/stat.h>
#include	<linux/fcntl.h>
#include	<linux/utime.h>
#include	<linux/unistd.h>
#include	<linux/signal.h>
#include	<linux/wait.h>
#include	<linux/net.h>
#include	<linux/in.h>
#endif

#if 0
typedef	unsigned int	size_t;
typedef	int		ssize_t;
typedef long		off_t;
typedef unsigned short	mode_t;
typedef	int		pid_t;
typedef unsigned short	uid_t;
typedef unsigned short	gid_t;
#endif
#define		socklen_t	int


extern ssize_t	_zx_read( int fd, void *ptr, size_t len );
extern ssize_t	_zx_write( int fd, const void *ptr, size_t len );
extern off_t	_zx_lseek( int fd, off_t pos, int dir );
extern int	_zx_close( int file );


extern int	_zx_fstat( int fd, struct stat *stbuf );
extern int	_zx_stat( const char *file, struct stat *st );
extern int	_zx_lstat( const char *file, struct stat *st );

extern int	_zx_open( const char *file, int flags, ... );
//extern int	_zx_open( const char *file, int flags, mode_t mode );
extern int	_zx_creat( const char *file, mode_t mode );

extern int	_zx_unlink( const char *file );
extern void	_zx_exit( int retcode );
extern int	_zx_kill( pid_t pid, int sig );

extern pid_t	_zx_wait( int *status );
extern pid_t	_zx_waitpid( pid_t pid, int *status, int potion );
extern pid_t	_zx_fork( void );
extern pid_t	_zx_getpid( void );
extern int	_zx_execve( const char *file,
				char *const argv[], char *const envp[] );

extern int	_zx_chmod( const char *file, mode_t mode );
extern int	_zx_fchmod( int fd, mode_t mode );
extern int	_zx_chown( const char *file, uid_t owner, gid_t group );
extern int	_zx_fchown( int fd, uid_t owner, gid_t group );
extern int	_zx_lchown( const char *file, uid_t owner, gid_t group );

extern int	_zx_utime( const char *file, struct utimebuf *buf );


// socket calls
extern long	_zx_socketcall( int call, unsigned long *args );

extern int	_zx_socket( int domain, int type, int protocol );
extern int	_zx_bind( int sockfd, struct sockaddr *myaddr,
						socklen_t addrlen );

extern int	_zx_connect( int sockfd, struct sockaddr *servaddr,
							socklen_t addrlen );
extern int	_zx_listen( int sockfd, int backlog );

extern int	_zx_accept( int sockfd, struct sockaddr *addr,
						socklen_t *addr_len );

extern int	_zx_getsockname( int sockfd, struct sockaddr *name,
						socklen_t *namelen );
extern int	_zx_getpeername( int sockfd, struct sockaddr *name,
						socklen_t *namelen );
extern int	_zx_socketpair( int sockfd, int type, int protocol,
						int sv[2] );
extern int	_zx_send( int sockfd, const void *msg, size_t len, int flags );
extern int	_zx_sendto( int sockfd, const void *msg, size_t len, int flags,
			const struct sockaddr *to, socklen_t tolen );
extern int	_zx_recv( int sockfd, void *buf, size_t len, int flags );
extern int	_zx_recvfrom( int sockfd, void *buf, size_t len, int flags,
			struct sockaddr *from, socklen_t fromlen );
extern int	_zx_shutdown( int sockfd, int how );
extern int	_zx_setsockopts( int sockfd, int level, int optname,
				const void *optval, socklen_t optlen );
extern int	_zx_getsockopts( int sockfd, int level, int optname,
				void *optval, socklen_t *optlen );
extern int	_zx_sendmsg( int sockfd, const struct msghdr *msg, int flags );
extern int	_zx_recvmsg( int sockfd, struct msghdr *msg, int flags );


#ifdef __cplusplus
}
#endif

#endif

